#include <fstream>
#include <cstring>
#include <algorithm>
using namespace std;

const int N = 1 + 3e7, Sigma = 256;

int skip[Sigma], need[Sigma];
char text[N], pattern[N];

int main(){
  ifstream in("password.in");
  ofstream out("password.out");
  in >> text >> pattern;

	sort(pattern, pattern + strlen(pattern));

    for (int i = 0; text[i]; i++)
    	skip[ text[i] ]++;
    for (int i = 0; pattern[i]; i++){
    	need[ pattern[i] ]++;
    	skip[ pattern[i] ]--;
    }
    for (int i = 0; i < Sigma; i++)
    	if ( skip[i] < 0 ){
    		out << "impossible\n";
    		return 0;
    	}

    int pos = 0;
    for (int i = 0; text[i]; i++)
        if ( need[ text[i] ] ){
            while ( pos && skip[ text[pos-1] ] && text[i] < text[pos-1] ){
                pos--;
                skip[ text[pos] ]--;
                need[ text[pos] ]++;
            }
            text[pos++] = text[i];
            need[ text[i] ]--;
        } else
        	skip[ text[i] ]--;

    text[pos] = '\0';
    out << text << '\n';

    return 0;
}
