#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;

const int N = 1 + 3e6;

char text[N], pattern[N];

bool is_sol(char* sol){
	int p = 0;
	for (int i = 0; text[i] && sol[p]; i++)
		if ( text[i] == sol[p] )
			p++;
	return !sol[p];
}

int main(int argc, char** argv){
	if ( argc == 2 )
		freopen(argv[1], "r", stdin);

  ifstream in("password.in");
  ofstream out("password.out");
	in >> text >> pattern;

	int size = strlen(pattern);
	sort(pattern, pattern + size);

	while ( !is_sol(pattern) && next_permutation(pattern, pattern + size));

	if ( is_sol(pattern) )
		out << pattern << '\n';
	else
		out << "impossible!\n";

	return 0;
}
